uniform sampler2D bgl_RenderedTexture;
uniform sampler2D bgl_DepthTexture;
 
const float blurclamp = 2;  // max blur amount
const float bias = 0.3; //aperture - bigger values for shallower depth of field 0.12
//uniform float focus;  // this value comes from ReadDepth script.

in vec2 UV;
 
void main()
{

	float f=1.0;
	float n = 0;
	float z = (2 * n) / (f + n - texture2D( bgl_DepthTexture, UV ).x * (f - n));

		float focus = 0.985;
        float aspectratio = 800.0/600.0;
        vec2 aspectcorrect = vec2(1.0,aspectratio);
       
        vec4 depth1   = texture2D(bgl_DepthTexture,UV );
 
       float factor = ( depth1.x - focus );
	   //float factor = (z - focus );
         
        vec2 dofblur = vec2 (clamp( factor * bias, -blurclamp, blurclamp ));
 
 
        vec4 col = vec4(0.0);
       
        col += texture2D(bgl_RenderedTexture, UV);
        col += texture2D(bgl_RenderedTexture, UV + (vec2( 0.0,0.4 )*aspectcorrect) * dofblur);
        col += texture2D(bgl_RenderedTexture, UV + (vec2( 0.15,0.37 )*aspectcorrect) * dofblur);
        col += texture2D(bgl_RenderedTexture, UV + (vec2( 0.29,0.29 )*aspectcorrect) * dofblur);
        col += texture2D(bgl_RenderedTexture, UV + (vec2( -0.37,0.15 )*aspectcorrect) * dofblur);       
        col += texture2D(bgl_RenderedTexture, UV + (vec2( 0.4,0.0 )*aspectcorrect) * dofblur);   
        col += texture2D(bgl_RenderedTexture, UV + (vec2( 0.37,-0.15 )*aspectcorrect) * dofblur);       
        col += texture2D(bgl_RenderedTexture, UV + (vec2( 0.29,-0.29 )*aspectcorrect) * dofblur);       
        col += texture2D(bgl_RenderedTexture, UV + (vec2( -0.15,-0.37 )*aspectcorrect) * dofblur);
        col += texture2D(bgl_RenderedTexture, UV + (vec2( 0.0,-0.4 )*aspectcorrect) * dofblur); 
        col += texture2D(bgl_RenderedTexture, UV + (vec2( -0.15,0.37 )*aspectcorrect) * dofblur);
        col += texture2D(bgl_RenderedTexture, UV + (vec2( -0.29,0.29 )*aspectcorrect) * dofblur);
        col += texture2D(bgl_RenderedTexture, UV + (vec2( 0.37,0.15 )*aspectcorrect) * dofblur); 
        col += texture2D(bgl_RenderedTexture, UV + (vec2( -0.4,0.0 )*aspectcorrect) * dofblur); 
        col += texture2D(bgl_RenderedTexture, UV + (vec2( -0.37,-0.15 )*aspectcorrect) * dofblur);       
        col += texture2D(bgl_RenderedTexture, UV + (vec2( -0.29,-0.29 )*aspectcorrect) * dofblur);       
        col += texture2D(bgl_RenderedTexture, UV + (vec2( 0.15,-0.37 )*aspectcorrect) * dofblur);
        col += texture2D(bgl_RenderedTexture, UV + (vec2( 0.15,0.37 )*aspectcorrect) * dofblur*0.9);
        col += texture2D(bgl_RenderedTexture, UV + (vec2( -0.37,0.15 )*aspectcorrect) * dofblur*0.9);           
        col += texture2D(bgl_RenderedTexture, UV + (vec2( 0.37,-0.15 )*aspectcorrect) * dofblur*0.9);           
        col += texture2D(bgl_RenderedTexture, UV + (vec2( -0.15,-0.37 )*aspectcorrect) * dofblur*0.9);
        col += texture2D(bgl_RenderedTexture, UV + (vec2( -0.15,0.37 )*aspectcorrect) * dofblur*0.9);
        col += texture2D(bgl_RenderedTexture, UV + (vec2( 0.37,0.15 )*aspectcorrect) * dofblur*0.9);            
        col += texture2D(bgl_RenderedTexture, UV + (vec2( -0.37,-0.15 )*aspectcorrect) * dofblur*0.9);   
        col += texture2D(bgl_RenderedTexture, UV + (vec2( 0.15,-0.37 )*aspectcorrect) * dofblur*0.9);   
        col += texture2D(bgl_RenderedTexture, UV + (vec2( 0.29,0.29 )*aspectcorrect) * dofblur*0.7);
        col += texture2D(bgl_RenderedTexture, UV + (vec2( 0.4,0.0 )*aspectcorrect) * dofblur*0.7);       
        col += texture2D(bgl_RenderedTexture, UV + (vec2( 0.29,-0.29 )*aspectcorrect) * dofblur*0.7);   
        col += texture2D(bgl_RenderedTexture, UV + (vec2( 0.0,-0.4 )*aspectcorrect) * dofblur*0.7);     
        col += texture2D(bgl_RenderedTexture, UV + (vec2( -0.29,0.29 )*aspectcorrect) * dofblur*0.7);
        col += texture2D(bgl_RenderedTexture, UV + (vec2( -0.4,0.0 )*aspectcorrect) * dofblur*0.7);     
        col += texture2D(bgl_RenderedTexture, UV + (vec2( -0.29,-0.29 )*aspectcorrect) * dofblur*0.7);   
        col += texture2D(bgl_RenderedTexture, UV + (vec2( 0.0,0.4 )*aspectcorrect) * dofblur*0.7);                
        col += texture2D(bgl_RenderedTexture, UV + (vec2( 0.29,0.29 )*aspectcorrect) * dofblur*0.4);
        col += texture2D(bgl_RenderedTexture, UV + (vec2( 0.4,0.0 )*aspectcorrect) * dofblur*0.4);       
        col += texture2D(bgl_RenderedTexture, UV + (vec2( 0.29,-0.29 )*aspectcorrect) * dofblur*0.4);   
        col += texture2D(bgl_RenderedTexture, UV + (vec2( 0.0,-0.4 )*aspectcorrect) * dofblur*0.4);     
        col += texture2D(bgl_RenderedTexture, UV + (vec2( -0.29,0.29 )*aspectcorrect) * dofblur*0.4);
        col += texture2D(bgl_RenderedTexture, UV + (vec2( -0.4,0.0 )*aspectcorrect) * dofblur*0.4);     
        col += texture2D(bgl_RenderedTexture, UV + (vec2( -0.29,-0.29 )*aspectcorrect) * dofblur*0.4);   
        col += texture2D(bgl_RenderedTexture, UV + (vec2( 0.0,0.4 )*aspectcorrect) * dofblur*0.4);     
		
		
		  
                       
      gl_FragColor = col/41.0;
		gl_FragColor.a = 1.0;

		/*if(depth1.x <0.998) {
      gl_FragColor =  texture2D(bgl_RenderedTexture, UV);
		}*/
}